//
// $Id: SunSignalHandler.java 6214 2010-10-18 18:01:12Z dhoover $
//
// Narya library - tools for developing networked games
// Copyright (C) 2002-2010 Three Rings Design, Inc., All Rights Reserved
// http://code.google.com/p/narya/
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

package com.threerings.presents.server;

import com.samskivert.util.RunAnywhere;
import com.samskivert.util.SignalUtil;

/**
 * Handles signals using Sun's undocumented Signal class.
 */
public class SunSignalHandler extends AbstractSignalHandler
{
    @Override
    protected boolean registerHandlers ()
    {
        SignalUtil.register(SignalUtil.Number.TERM, new SignalUtil.Handler() {
            public void signalReceived (SignalUtil.Number sig) {
                termReceived();
            }
        });
        SignalUtil.register(SignalUtil.Number.INT, new SignalUtil.Handler() {
            public void signalReceived (SignalUtil.Number sig) {
                intReceived();
            }
        });
        SignalUtil.register(SignalUtil.Number.USR2, new SignalUtil.Handler() {
            public void signalReceived (SignalUtil.Number sig) {
                usr2Received();
            }
        });
        if (!RunAnywhere.isWindows()) {
            SignalUtil.register(SignalUtil.Number.HUP, new SignalUtil.Handler() {
                public void signalReceived (SignalUtil.Number sig) {
                    hupReceived();
                }
            });
        }
        return true;
    }
}
